Gitlab :

      1) Finest Folder structure for Micro services Architecture.
      
      2) Worlds best Branching Strategy.

      3) Focused on Protected branches to avoid Accidential Pushes.

      4) Good workflow for MR approvals with help of Assignee and Reviewer. 

      5) Test every feature branche before pushing to main branche.

      6) Excellent automation to trigger the build pipelines ( Feature and Master) with webhooks.


Jenkins :

       1) Folder structure simillar to Gitlab folder structure.

       2) create CI / CD and Release pipelines

       3) add more


JFROG  :

       1) setup a jfrog project 

       2) assign a role/user to that project which has the deployment access 

       3) create a repository for each micro-service
                    1) mana-shop-Shop-UI
                    2) mana-shop-Stock-Manager
                    3) mana-stop-Product-Catalogue


Google artifact registry :

    1) create a seperate artifact repository for each micro-service with small letters
                   1) mana-shop-shop-ui 
                   2) mana-shop-stock-manager 
                   3) mana-shop-product-catalogue 
              q) what is immutable tags option in GAR?

Docker:
     
       1) Minimilistic docker image   // need to docker
       2) perfect docker-compose file
       3) need to think volume and network for containers


Linux:



Bash :

     unlock the power of deployment.sh script 


Monitoring:




immediate tasks:

    
   1) write a perfect docker-compose file
     done but think how can we custmize the product-catalogue container name custmize if container name changes then shop-ui not able to connect prodcut-catalogue service


   2) create CD pipelines for each mmicro-services  //done
   3) add the actuorate for each micro service
   4) monitoring the server and mS's
 




  Add the actuorate for each micro service: 

     Spring Boot Actuator: if your apps are based on spring boot then you can monitor and manage the apps.

     it provides a number of end points:

        1) beans: list of beans

        2) health

        3) app metrics

     How can we do that?

        add below dependency in app pom.xml file
          
            <dependency>
                  <groupId>org.springframework.boot</groupId>
                  <artifactId>spring-boot-starter-actuator</artifactId>
            </dependency>

       add one line in app.prop file




      

       


       

       
